summaryrefslogtreecommitdiff
path: root/tests/misc
diff options
context:
space:
mode:
authorJim Meyering <jim@meyering.net>2007-09-10 21:29:46 +0200
committerJim Meyering <jim@meyering.net>2007-09-15 08:40:39 +0200
commit1529be605114dab54f82779babcd0793ec931aa7 (patch)
treef10f13c0d62703b673695bdaaf24c8e8a010e613 /tests/misc
parent47b7234de3600a3777f015ad4792dda622b0a921 (diff)
downloadcoreutils-1529be605114dab54f82779babcd0793ec931aa7.tar.xz
Move the sole test in tests/tsort/ to tests/misc/tsort.
* tests/tsort/basic-1: Move this file to ... * tests/misc/tsort: ...here. Don't rely on $PROG in env. * tests/misc/Makefile.am (TESTS): Add tsort. * tests/Makefile.am (SUBDIRS): Remove tsort. * tests/tsort: Remove the directory. * configure.ac (AC_CONFIG_FILES): Remove tests/tsort/Makefile.
Diffstat (limited to 'tests/misc')
-rw-r--r--tests/misc/Makefile.am1
-rwxr-xr-xtests/misc/tsort81
2 files changed, 82 insertions, 0 deletions
diff --git a/tests/misc/Makefile.am b/tests/misc/Makefile.am
index 7decb29fd..6b7d279c3 100644
--- a/tests/misc/Makefile.am
+++ b/tests/misc/Makefile.am
@@ -103,6 +103,7 @@ TESTS = \
stat-printf \
tac-continue \
test-diag \
+ tsort \
tty-eof \
unexpand
diff --git a/tests/misc/tsort b/tests/misc/tsort
new file mode 100755
index 000000000..790502034
--- /dev/null
+++ b/tests/misc/tsort
@@ -0,0 +1,81 @@
+#!/bin/sh
+# -*- perl -*-
+# Test "tsort".
+
+# Copyright (C) 1999, 2000, 2003-2007 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+: ${PERL=perl}
+: ${srcdir=.}
+
+$PERL -e 1 > /dev/null 2>&1 || {
+ echo 1>&2 "$0: configure didn't find a usable version of Perl," \
+ "so can't run this test"
+ exit 77
+}
+
+me=`echo $0|sed 's,.*/,,'`
+exec $PERL -w -I$srcdir/.. -MCoreutils -M"CuTmpdir qw($me)" -- - <<\EOF
+#/
+require 5.003;
+use strict;
+
+(my $program_name = $0) =~ s|.*/||;
+
+# Turn off localisation of executable's ouput.
+@ENV{qw(LANGUAGE LANG LC_ALL)} = ('C') x 3;
+
+my @Tests =
+ (
+ ['cycle-1', {IN => {f => "t b\nt s\ns t\n"}}, {OUT => "s\nt\nb\n"},
+ {EXIT => 1},
+ {ERR => "tsort: f: input contains a loop:\ntsort: s\ntsort: t\n"} ],
+ ['cycle-2', {IN => {f => "t x\nt s\ns t\n"}}, {OUT => "s\nt\nx\n"},
+ {EXIT => 1},
+ {ERR => "tsort: f: input contains a loop:\ntsort: s\ntsort: t\n"} ],
+
+ ['posix-1', {IN => "a b c c d e\ng g\nf g e f\nh h\n"},
+ {OUT => "a\nc\nd\nh\nb\ne\nf\ng\n"}],
+ ['posix-2', {IN => "b a\nd c\nz h x h r h\n"},
+ {OUT => "b\nd\nr\nx\nz\na\nc\nh\n"}],
+
+ ['linear-1', {IN => "a b b c c d d e e f f g\n"},
+ {OUT => "a\nb\nc\nd\ne\nf\ng\n"}],
+
+ ['tree-1', {IN => "a b b c c d d e e f f g\nc x x y y z\n"},
+ {OUT => "a\nb\nc\nx\nd\ny\ne\nz\nf\ng\n"}],
+ ['tree-2', {IN => "a b b c c d d e e f f g\nc x x y y z\nf r r s s t\n"},
+ {OUT => "a\nb\nc\nx\nd\ny\ne\nz\nf\nr\ng\ns\nt\n"}],
+
+ # Before coreutils-5.0.1, given an odd number of input tokens,
+ # tsort would accept that and treat the input as if an additional
+ # copy of the final token were appended.
+ ['odd', {IN => "a\n"},
+ {EXIT => 1},
+ {ERR => "tsort: odd.1: input contains an odd number of tokens\n"}],
+
+ ['only-one', {IN => {f => ""}}, {IN => {g => ""}},
+ {EXIT => 1},
+ {ERR => "tsort: extra operand `g'\n"
+ . "Try `tsort --help' for more information.\n"}],
+ );
+
+my $save_temps = $ENV{DEBUG};
+my $verbose = $ENV{VERBOSE};
+
+my $prog = 'tsort';
+my $fail = run_tests ($program_name, $prog, \@Tests, $save_temps, $verbose);
+exit $fail;
+EOF